#include <stdio.h>
//#include <math.h>
#include "clus.h"
void tractarnomgenoma(char *dir){
  int i=0,j;
  int ultim=0;
  //buscar darrer /
  while (dir[i] != '\0'){
    if (dir[i]=='/') ultim = i+1;
    i++;
  }
  for (j=ultim;j<i;j++) dir[j-ultim]=dir[j];
  dir[i-ultim-3]='\0';//el -3 treu el .fa
  
}


//versio iterativa com funcio
char* carpatro(int r,int l, unsigned int base){ // r=long patro l=valor
  char c;
  //char *patro;
  char patro[r+1];
  int reste;
  //if(!(patro = malloc(r*sizeof(char)))){ printf("size NOK \n");exit(0);}
  patro[r]='\0';
  while (r>0){
    reste = l%base;
    l =(int) l / base;
    switch (reste){
    case 0 : c='A';break;
    case 1 : c='C';break;
    case 2 : c='G';break;
    case 3 : c='T';break;
    case 4 : c='N';break;
    default:break;
      //printf("%c",c);
    }
    patro[r-1]=c;
    r--;
  }
  //printf("%s\n",patro);
  return patro;
}

void initaula(FILE *ftaula){
  fprintf(ftaula,"%-25s%-30s%10s%12s%12s%10s%8s%8s%20s%20s\n","Genome","Satellite name","Contig","Start","End","Sat.","Number","Repeat","Seed motif","Representative");
  fprintf(ftaula,"%99s%8s%8s%35s\n","length","repeats","length","repeat");
  
}
void imprimir(FILE *ftaula, char *nomgenoma, unsigned long int inf,char* nomsatellit, unsigned long int contig, unsigned long int iniclus, unsigned long int ficlus,unsigned long int satlength,unsigned int nrepeats,int repeatlength,unsigned long int longpatro, unsigned long int escollit,int base){

  char *patro;
  char s1[MAXLONGCONTIG],s2[MAXLONGPUNTER],s[MAXLONGNOMSATELLIT];
  double score;

  //calculo puntuacio
  //score=log(inf)+(nrepeats-1)*(log(satlength)-log(nrepeats)-log(4)*repeatlength);
  //printf("longpatro %d\n",longpatro);
  
  sprintf(s1,"%lu",contig);
  sprintf(s2,"%lu",iniclus);
  strcpy(s,nomsatellit);
  strcat(s,"_");
  strcat(s,s1);
  strcat(s,":");
  strcat(s,s2);

  patro = (char *) malloc ((MAXLONGNOMSATELLIT)*sizeof(char ));
  if (patro == NULL) {printf("\n Error funcionsvaries:patro");exit(0);}
  patro = carpatro(longpatro,escollit,base);
  printf(">%s_%lu:%lu-%lu Satlength=%lu Nr of Repeats=%u RepeatLength=%d seed=%s  \n",nomsatellit,contig,iniclus,ficlus,satlength,nrepeats,repeatlength,patro);
  //printf("Patro %s\n",patro);
  //fprintf(ftaula,"Patro %s\n",patro);
  
  fprintf(ftaula,"%-25s%-30s%10lu%12lu%12lu%10lu%8u%8d%20s     ",nomgenoma,s,contig,iniclus,ficlus,satlength,nrepeats,repeatlength,patro);
}



int valorcar(char c){
  //relacio caracter -enter
  int res;
  switch (c){
  case 'A': res=0;break;
  case 'C': res=1;break;
  case 'G': res=2;break;
  case 'T': res=3;break;
  case 'N': res=4;break;
  default:break;
  }
  return(res);
}
int potencia(int base, int exp){
  int res;
  res=1;
  while (exp>0) { 
    res=res*base;
    exp--;
  }
  return res;
}

unsigned long int maxim(unsigned long int x,unsigned long int y){
  if (y>x) return y;
  else return x;
}

unsigned long int minim(unsigned long int x,unsigned long int y){
  if (y<x) return y;
  else return x;
}
	     
int rotacio(unsigned long int x,unsigned long int y, int longpatro, unsigned long int potencia, unsigned int base){
  int res=0;
  int i=1;
  int val;
  while ((res==0) && (i<longpatro)){
    val=x%base;
    x=((int)((x-val)/base))+val*potencia;
    res=(x==y);
    //printf("x=%u y=%u res=%d",x,y,res);
    i++;
  }
  //printf("\n");
  return res;
}
int periode(unsigned long int x, int longpatro, unsigned long int potencia, unsigned int base){
  //retorna la long del periode  
  int res;
  int i=1;
  unsigned long int val;
  res=x%base;
  val=((int)((x-res)/base))+res*potencia;
  while ((i<=((int)longpatro/2)) && (val!=x)){
    res=val%base;
    val=((int)((val-res)/base))+res*potencia;
    //carpatro(longpatro,x,base);
    //printf("x=%u val=%u i=%d\n",x,val,i);
    i++;
  }
  //printf("\n");
  if (val==x) return (int)(longpatro/i);
  else return 1;
}

int te3micros(unsigned long int x, int longpatro, unsigned long int potencia, unsigned int base){
  int p,q;
  //carpatro(longpatro,x,base);
  p=x%base;
  //printf("\np=%d",p);
  q=(int)((x-x%potencia)/potencia);
  //printf("\nq=%d",q);
  //printf("\nperiode=%d",periode((int)((x-p)/base),longpatro-1,(int)(potencia/base),base));
  return ((p==q) &&  (periode((int)((x-p)/base),longpatro-1,(int)(potencia/base),base)!=1));
}

int temicros(unsigned long int x, int longpatro, unsigned long int potencia, unsigned int base){
  int p,q,r,z,base2;
  //MIRO 331 I PRIMER=DESE
  //carpatro(longpatro,x,base);
  p=x%base;
  //printf("\np=%d",p);
  q=(int)((x-x%potencia)/potencia);
  //printf("\nq=%d",q);
  //printf("\nperiode=%d",periode((int)((x-p)/base),longpatro-1,(int)(potencia/base),base));
  z=periode((int)((x-p)/base),longpatro-1,(int)(potencia/base),base);
  r=((p==q) &&  (z!=1));
//MIRO 442 I DOSPRIMERS=DOSULTIMS
  potencia=potencia/base;
  base2=base*base;
  p=x%base2;
  q=(int)((x-x%potencia)/potencia);//printf("\n");
  //carpatro(longpatro-2,(x-p)/base2,base);
  z=periode((int)((x-p)/base2),longpatro-2,(int)(potencia/base),base);
  //printf("\n %d %d %d ",p,q,z);
  r=r || ((p==q) &&  (z!=1));
  return r;
}

void filtrepatrons(int *filtre,int longpatro,int base){
  long unsigned int p,q;
  int j,lseed,base1,base2,base3,base4,base5,base6,i1,i2,i3,i4,i5,i6,ult;
  base1=base;base2=base1*base;base3=base2*base;base4=base3*base;base5=base4*base;base6=base5*base;
  //filtre 11...1
  lseed=1;
  //   printf("lseed=%d\n",lseed);
  if (longpatro>=lseed*2)
    for (i1=0;i1<4;i1++){
      p=i1;q=0;
      for (j=0;j<longpatro;j++) q = q * base1 + p;
      filtre[q]=1;
      //printf("%lu\n",q);
    }
  //filtre 22..2 amb 1?
  lseed=2;
  //printf("lseed=%d\n",lseed);
  ult=(int)longpatro/lseed;
  if (longpatro>=lseed*2)
    for (i1=0;i1<4;i1++){
      for (i2=0;i2<4;i2++){
	p=i1*base1+i2; q=0;
	//printf("i2=%d p=%lu ult=%d\n",i2,p,ult);
	for (j=0;j<ult;j++) q = q * base2 + p;
	if (ult*lseed!=longpatro) q=q*base1+i1;
	filtre[q]=1;
	//printf("%lu\n",q);
      }
    }
  //filtre 33..3 amb 1? 2?
  lseed=3;
  //printf("lseed=%d\n",lseed);
  ult=(int)longpatro/lseed;
  if (longpatro>=lseed*2)
    for (i1=0;i1<4;i1++){
      for (i2=0;i2<4;i2++){
	for (i3=0;i3<4;i3++){
	  p=i1*base2+i2*base1+i3;
	  q=0;
	  for (j=0;j<ult;j++) q = q * base3 + p;
	  if (ult*lseed!=longpatro) {
	    q=q*base1+i1;
	    if (ult*lseed+1!=longpatro) q=q*base1+i2;
	  }
	  filtre[q]=1;
	  //printf("%lu\n",q);
	}
      }
    }
  //filtre 44..4 amb 1? 2? 3
  lseed=4;
  //printf("lseed=%d\n",lseed);
  ult=(int)longpatro/lseed;
  if (longpatro >=lseed*2)
    for (i1=0;i1<4;i1++){
      for (i2=0;i2<4;i2++){
	for (i3=0;i3<4;i3++){
	  for (i4=0;i4<4;i4++){
	    p=i1*base3+i2*base2+i3*base1+i4;
	    q=0;
	    for (j=0;j<ult;j++) q = q * base4 + p;
	    if (ult*lseed!=longpatro){
	      q=q*base1+i1;
	      if (ult*lseed+1!=longpatro){
		q=q*base1+i2;
		if (ult*lseed+2!=longpatro) q=q*base1+i3;
	      }
	    }
	    filtre[q]=1;
	    //      printf("%lu\n",q);
	  }
	}
      }
    }
  //filtre 55...5 amb 1? 2? 3? 4?
  lseed=5;
    //printf("lseed=%d\n",lseed);
  ult=(int)longpatro/lseed;
  if (longpatro>=lseed*2)
    for (i1=0;i1<4;i1++){
      for (i2=0;i2<4;i2++){
	for (i3=0;i3<4;i3++){
	  for (i4=0;i4<4;i4++){
	    for (i5=0;i5<4;i5++){
	      p=i1*base4+i2*base3+i3*base2+i4*base1+i5;
	      q=0;
	      for (j=0;j<ult;j++) q = q * base5 + p;
	      if (ult*lseed!=longpatro){
		q=q*base1+i1;
		if (ult*lseed+1!=longpatro){
		  q=q*base1+i2;
		  if (ult*lseed+2!=longpatro){
		    q=q*base1+i3;
		    if (ult*lseed+3!=longpatro) q=q*base1+i4;
		  }
		}
	      }
	      filtre[q]=1;
	      //		printf("%lu\n",q);
	    }
	  }
	}
      }
    }
  //filtre 66...6 amb 1? 2? 3? 4? 5?
  lseed=6;
  //    printf("lseed=%d\n",lseed);
  ult=(int)longpatro/lseed;
  if (longpatro>=lseed*2)
    for (i1=0;i1<4;i1++){
      for (i2=0;i2<4;i2++){
	for (i3=0;i3<4;i3++){
	  for (i4=0;i4<4;i4++){
	    for (i5=0;i5<4;i5++){
	      for (i6=0;i6<4;i6++){
		p=i1*base5+i2*base4+i3*base3+i4*base2+i5*base1+i6;
		q=0;
		for (j=0;j<ult;j++) q = q * base6 + p;
		if (ult*lseed!=longpatro){
		  q=q*base1+i1;
		  if (ult*lseed+1!=longpatro){
		    q=q*base1+i2;
		    if (ult*lseed+2!=longpatro){
		      q=q*base1+i3;
		      if (ult*lseed+3!=longpatro){
			q=q*base1+i4;
			if (ult*lseed+4!=longpatro) q=q*base1+i5;
		      }
		    }
		  }
		}
		filtre[q]=1;
		//		  printf("%lu\n",q);
	      }
	    }
	  }
	}
      }
    }
}


filtrepatronsant(int *filtre,int longpatro,int base){
  int i1,i2,i3,i4,i5,j;
  unsigned long int p,q,pot2,pot3,pot4,pot5;
  //printf("base=%d",base);
  if (longpatro==10){
    //filtro 1111111111,22222
    pot2=base*base;
    for (i1=0;i1<4;i1++)
      for (i2=0;i2<4;i2++){
	p=0;q=i1*base+i2;
	for (j=1;j<6;j++) p=p*pot2+q;
	filtre[p]=1;
	//printf("\n");carpatro(longpatro,p,base);printf("  %u  %d  ",p, filtre[p]);
      }
    if (base==5){ 
      p=0;q=24;
      for (j=1;j<6;j++) p=p*pot2+q;
      filtre[p]=1;
    }
    
    //filtro 3331
    pot3=pot2*base;
    for (i1=0;i1<4;i1++)
      for (i2=0;i2<4;i2++)
	for (i3=0;i3<4;i3++){
	  p=0;q=i1*pot2+i2*base+i3;
	  for (j=1;j<4;j++) p=p*pot3+q;
	  p=p*base+i1;
	  //printf("\n");carpatro(longpatro,p,base);
	  filtre[p]=1;
	}
    //filtro 442
    pot4=pot3*base;
    for (i1=0;i1<4;i1++)
      for (i2=0;i2<4;i2++)
	for (i3=0;i3<4;i3++)
	  for (i4=0;i4<4;i4++){
	    p=0;q=i1*pot3+i2*pot2+i3*base+i4;
	    for (j=1;j<3;j++) p=p*pot4+q;
	    p=p*pot2+i1*base+i2;
	    //printf("\n");carpatro(longpatro,p,base);
	    filtre[p]=1;
	  }
    //filtro 55
    pot5=pot4*base;
    for (i1=0;i1<4;i1++)
      for (i2=0;i2<4;i2++)
	for (i3=0;i3<4;i3++)
	  for (i4=0;i4<4;i4++)
	    for (i5=0;i5<4;i5++){
	      p=0;q=i1*pot4+i2*pot3+i3*pot2+i4*base+i5;
	      for (j=1;j<3;j++) p=p*pot5+q;
	      //printf("\n");carpatro(longpatro,p,base);
	      filtre[p]=1;
	    }
  }
  else if (longpatro==3){
    //filtro 111
    for (i1=0;i1<4;i1++){
      p=0;
      for (i2=0;i2<3;i2++)
	p=p*base+i1;
	//printf("\n");carpatro(longpatro,p,base);
      filtre[p]=1;
      }
  }
}
	     
