#include <stdio.h>
#include <stdlib.h>
typedef struct
  {
    float *freq;   //Vector de frequencia de cada caracter. 
    float gap_ini; //Prob. Gap a l'inici o a la fi del cluster
    float gap_op; //Prob. Gap opening
    float gap_ext; //Prob. Gap extension
    float nogaps;//compta els no gaps
    //float puntuacio;
    float puntsintracluster;//puntuacio intra cluster
    //float puntintraclusternoop;//puntuacio intra cluster sense gap openings
  } tsinfo_cluster_columna;
  
  typedef struct
  {
    int num_cluster;//numero del cluster
    char *nom_seq; //nom de la sequencia
    int long_seq;
    int num_seqs;    //Nombre de seq��ncies del cluster
    int *quines;//Quines sequencies formen el cluster
    long lcluster;  //Longitud de les seq��ncies del cluster
    float puntuacio;//puntuacio de l'alineament
    tsinfo_cluster_columna *perfil;
  } tscluster;

tscluster *clusters;

void inicialitzar_perfil_cluster(tsinfo_cluster_columna * ,int);
void determinar_perfil_desde_alineament(int ** seqalin,tscluster *,int, float **);
void llegir_clusters(char *, int, int, int, int, int);
void llegir_ordenar_clusters(char *nomfitxerentrada,int numseqs, int alf, int midaalf, int longmer, int revseq);
void escriure_sortida_cluster(int , int , int, int,int,int,int,int);
void reconstruir_nou_cluster(char *, char *, tscluster *, tscluster, int , int, float **);
void mostrar_info_cluster(tscluster, int );
void crea_perfil_complementari(int ,int ,int ,int);
int complementari(int ,int ,int);
void omple_fitxer_complementari(int,int,int);
int get_concensus(char* , int,int ,int ,int,int,int );
void get_asterix(char* , int , int ,int,int ,int);
