#include "clus.h"
#include "clusters.h"
#include <stdio.h>
#include "funcionsvaries.h"
#include <stdlib.h>
#include "auxiliar.h"
#include "tractarclusters.h"

void tractar_cluster(FILE *ftaula, char *gen,int longpatro,int numrepeats,int base ,unsigned long int escollit,unsigned long int inicluster,unsigned long int ficluster, int errorscluster,int esc_repeats_escollits,int long_rep_acceptats, int infoalign,int rangacceptats,int esc_tots_repeats, int esc_repre,int esc_concensus,int esc_alin,int alin_tots_repeats, int alin_repeats_escollits)
{
  FILE *seqsf;
  char patro[MAXLONGPATRO];
  //printf("A\n");
  int freqlong[MAXLONGCLUSTER],suma;
  int d,i,j,m,ant,longint,numseq,repadmes,longrep,longrepmig,llargadarepeat,len,escritrepre;
 
   m=escollit;
   longint=minim(ficluster-inicluster+1,MAXLONGCLUSTER-1);
  // a posinirepeat hi ha un 1 on comencar cada repeat calculat a esacceptat
  //printf("Repeats trobats %d\n",numrepeats);
  //escriure el primer repeat com representant
   escritrepre=0;
   if ((esc_repre==1) && (escritrepre==0)){
     i=1;
     while ((posinirepeats[i]==0) && (i<=longint)) i++;
     while ((i<=longint) && (escritrepre == 0)){
       //printf("esc_repeats_escollits=%d long_rep_acceptats=%d\n",esc_repeats_escollits,long_rep_acceptats);
       llargadarepeat=1;
       while (((posinirepeats[i+llargadarepeat]==0) || (ant+longpatro>i+llargadarepeat)) && (i+llargadarepeat<=longint)) llargadarepeat++;
       //printf("llargadarepeat %d > long_rep_acceptats %d -rangacceptats %d) &&(llargadarepeat %d <=long_rep_acceptats %d\n",llargadarepeat,long_rep_acceptats,rangacceptats,llargadarepeat,long_rep_acceptats);
       if ((llargadarepeat>long_rep_acceptats-rangacceptats) &&(llargadarepeat<=long_rep_acceptats)) { 
	 printf("%c",gen[inicluster+i-1]);
	 fprintf(ftaula,"%c",gen[inicluster+i-1]);
	 ant=i;
	 i++;
	 while (((posinirepeats[i]==0) || (ant+longpatro>i)) && (i<=longint)){
	   printf("%c",gen[inicluster+i-1]);
	   fprintf(ftaula,"%c",gen[inicluster+i-1]);
	   i++;
	 }
	 printf("\n");
	 fprintf(ftaula,"\n");
	 escritrepre=1;
       }
       else{
	 ant=i;
	 i++;
	 while (((posinirepeats[i]==0) || (ant+longpatro>i)) && (i<=longint)) i++;
       }
     }
   }

   //escriu els repeats trobats
   if (esc_tots_repeats){
     i=1;
     while ((posinirepeats[i]==0) && (i<=longint)) i++;
     while (i<=longint){
       //printf("esc_repeats_escollits=%d long_rep_acceptats=%d\n",esc_repeats_escollits,long_rep_acceptats);
       if (esc_repeats_escollits == 1) {
	 llargadarepeat=1;
	 while (((posinirepeats[i+llargadarepeat]==0) || (ant+longpatro>i+llargadarepeat)) && (i+llargadarepeat<=longint)) llargadarepeat++;
       }
       if ((esc_repeats_escollits == 0) || ((esc_repeats_escollits == 1) && (llargadarepeat>long_rep_acceptats-rangacceptats) &&(llargadarepeat<long_rep_acceptats+rangacceptats))) { 
	 printf("%c",gen[inicluster+i-1]);
	 ant=i;
	 i++;
	 while (((posinirepeats[i]==0) || (ant+longpatro>i)) && (i<=longint)){
	   printf("%c",gen[inicluster+i-1]);
	   i++;
	 }
	 printf("\n");
       }
       else{
	 ant=i;
	 i++;
	 while (((posinirepeats[i]==0) || (ant+longpatro>i)) && (i<=longint)) i++;
       }
     }
   }
   //printf("infoalign=%d, esc_repeats_escollits=%d, long_rep_acceptats=%d\n",infoalign,esc_repeats_escollits,long_rep_acceptats);
   
   //printf("inicialitza clusters i matseqs\n");
   if (infoalign>0) {
     numseq=1;
     i=1;
     while ((posinirepeats[i]==0) && (i<=longint)) i++;
     while (i<=longint){
       //printf("infoalign=%d alin_repeats_escollits=%d long_rep_acceptats=%d\n",infoalign,alin_repeats_escollits,long_rep_acceptats);
       if (alin_repeats_escollits == 1) {
	 llargadarepeat=1;
	 while (((posinirepeats[i+llargadarepeat]==0) || (ant+longpatro>i+llargadarepeat)) && (i+llargadarepeat<=longint)) llargadarepeat++;
       }
       if ((alin_repeats_escollits == 0) || ((alin_repeats_escollits == 1) && (llargadarepeat>long_rep_acceptats-rangacceptats) &&(llargadarepeat<long_rep_acceptats+rangacceptats))) { 
	 matseqs[numseq-1][0]= acgt2ulint(gen[inicluster+i-1]);
	 //printf("%c",gen[inicluster+i-1]);
	 ant=i;
	 i++;
	 len=1;
	 while (((posinirepeats[i]==0) || (ant+longpatro>i)) && (i<=longint) && (len<MAXLONGSEQ)){
	   matseqs[numseq-1][len]= acgt2ulint(gen[inicluster+i-1]);
	   //printf("%d-%c-%d",len,gen[inicluster+i-1],matseqs[numseq-1][len]);
	   len++;
	   i++;
	 }
	 while (((posinirepeats[i]==0) || (ant+longpatro>i)) && (i<=longint)){
	   i++;
	 }
	 //printf("\n");
	 //creo cluster
	 clusters[numseq-1].num_cluster=numseq-1;
	 sprintf(clusters[numseq-1].nom_seq,">%d\0",numseq-1);
	 clusters[numseq-1].long_seq=len;
	 clusters[numseq-1].num_seqs=1;
	 clusters[numseq-1].quines[0]=numseq-1;
	 clusters[numseq-1].lcluster=len;
	 clusters[numseq-1].puntuacio=0;
	 inicialitzar_perfil_cluster(clusters[numseq-1].perfil,0);
	 for (j=0;j<len;j++){
	   clusters[numseq-1].perfil[j].freq[matseqs[numseq-1][j]]=1;
	   clusters[numseq-1].perfil[j].nogaps=1;
	   clusters[numseq-1].perfil[j].gap_ini=0;
	   clusters[numseq-1].perfil[j].gap_op=0;
	   clusters[numseq-1].perfil[j].gap_ext=0;
	   clusters[numseq-1].perfil[j].puntsintracluster=0;
	 }
	 //printf("mostro cluster\n");
	 //mostrar_info_cluster(clusters[numseq-1],0);
	 numseq++;
       }
       else{
	 ant=i;
	 i++;
	 while (((posinirepeats[i]==0) || (ant+longpatro>i)) && (i<=longint)) i++;
       }
     }
     align(numseq-1,0,infoalign,40,matpesos,esc_concensus,esc_alin,numrepeats);
   }
}

//troba els repeats
//fa la taula de frequencies de les seves llargades
//busca el interval amb un maxim numero de repeats
//accepta si compleix els minims
void esacceptat(char *gen,int longpatro,int *numrepeats,int base ,unsigned long int escollit,unsigned long int inicluster,unsigned long int ficluster, int errorscluster, int *acceptats,int *rebutjats,int *infoacceptat, int *long_rep_acceptats,int *percentatgeacceptats,int *minnumrepaccep, int rangacceptats,int minlrep,int maxlrep, int minnumrepcluster)
{
  //retorna infoacceptat,longacceptat
  //FILE *seqsf;
  char patro[MAXLONGPATRO];
  int freqlong[MAXLONGCLUSTER],suma,minnumreps;
  int d,i,j,k,m,ant,longint,numseq,numreps,repadmes,longrep,longrepmig,pos,max;
  double H,h,score;
  m=escollit;
  //decodifico el patro
  for (j=longpatro;j>0;j--){
    patro[j]= m%base;
    m=(int)((m-m%base)/base);
    //printf("-%d-",patro[j]);
  }
  //printf("\n");
  longint=minim(ficluster-inicluster+1,MAXLONGCLUSTER-1);
  //BUSCO EL PATRO AL CLUSTER

  //printf("inicialitzo matriu de prog. dinamica amb enters\n");
  
  //inicialitzo matriu dinamica
  progdim[0][0]=0;
  for (i=1;i<=longint;i++) {
    progdim[i][0]=0; //valorcar(gen[inicluster+i-1]);
    progdimcami[i][0]='a';
  }
  for (j=1;j<=longpatro;j++){
    progdim[0][j]=j;
    progdimcami[0][j]='e';
  }
  progdimcami[0][0]='d';
  //Omplo matriu dinamica
  for (i=1;i<=longint;i++)
    for (j=1;j<=longpatro;j++){
      d=progdim[i-1][j-1];
      if (valorcar(gen[inicluster+i-1])!=patro[j]) d=d+1;
      progdim[i][j]=minim(minim(progdim[i-1][j]+1,progdim[i][j-1]+1),d);
      if (progdim[i][j]==progdim[i][j-1]+1) progdimcami[i][j]='e';
      else if (progdim[i][j]==d) progdimcami[i][j]='d';
      else progdimcami[i][j]='a';
      //printf("%d==%(progdim[i][j]==d?--[%d][%d]=%d\n",valorcar(gen[inicluster+i-1]),patro[j],i,j,progdim[i][j]);
    }
  //posinirepeats tindra un 1 al principi de cada repeat trobat
  numreps=0;
  for (i=1;i<=longint;i++) posinirepeats[i]=0;
  i=1;ant=0;
  while ((progdim[i][longpatro]>errorscluster) && (i<=longint)) i++;
  //printf("%d\n",i);
  while (i<longint){
    if ((progdim[i][longpatro]<=errorscluster) && (progdim[i][longpatro]<progdim[i+1][longpatro])){
      //miro on comença el repeat
      j=i;
      k=longpatro;
      while (k>0){
	switch (progdimcami[j][k]){
	case 'e':k--;break;
	case 'd':k--;j--;break;
	case 'a':j--;break;
	}
      }
      ant=j+1;
      //ant=i-longpatro+1;
      //printf("ant=%d\n",ant);
      posinirepeats[ant]=1;
      i=i+longpatro+1-errorscluster;
      numreps++;
    }
    else i++;
    //i++;
    //while (((progdim[i][longpatro]>0) || (ant+longpatro>i)) && (i<=longint))
    //  i++;
  }
  *numrepeats=numreps;
  //Estadistica dels repeats trobats
  for (i=0;i<=longint;i++) freqlong[i]=0;
  //printf("\n numreps=%d longrepmig=%d\n",numreps,longrepmig);
  //repadmes=0;
  i=1;
  while ((posinirepeats[i]==0) && (i<=longint)) i++;
  while (i<=longint){
    longrep=0;
    ant=i;
    for (j=i+1;j<ant+longpatro;j++) posinirepeats[j]=0;
    while (((posinirepeats[i]==0) || (ant+longpatro>i)) && (i<=longint)){
      longrep++;  
      i++;
    }
    //printf("lr=%d --",longrep);
    freqlong[longrep]++;
  }
  //for (i=0;i<=100;i++) printf("freq[%d]=%d --",i,freqlong[i]);printf("\n\n");
//calculo l'entropia de la distribucio
  /*H=0;
  for (i=0;i<longint;i++) 
    if (freqlong[i]>0){
      h=(double)freqlong[i]/numreps;
      //printf("i= %d freqlong[i]= %d H=%f h=%f log(h) %f\n",i,freqlong[i],H,h,log(h));
      H = H + log(h)/log(2)*h;
    }
  printf("Entropia = %f\n",H);
  */
  max=0;
  suma=0;
  
  // busco interval d'amplada rangacceptats amb el maxim de repeats
  for (i=1;i<=rangacceptats;i++) suma=suma+freqlong[i];
  while (i<=longint) {
    if (suma>max){max=suma;pos=i;}
    i++;
    suma=suma-freqlong[i-rangacceptats]+freqlong[i];
  }
  minnumreps=maxim(numreps*(*percentatgeacceptats)/100,*minnumrepaccep);

  *long_rep_acceptats=0;
  //  printf("min %d  max %d pos=%d\n",minlrep,maxlrep,pos);
  //cal acceptar els que son majors que minlrep i menors que maxlrep
  if ((max>=minnumreps) && (pos>=minlrep) && (pos<=maxlrep) && numreps>=minnumrepcluster) {
    //calculo el RE de les bases afegides al repeat inicial
    //score=log(comb_nk(numreps,minnumreps))/log(2)+(minnumreps-1)*(pos-10)*(-log(4)/log(2));
    *infoacceptat=1;
    (*acceptats)++;
    //printf("\n ACCEPTAT\n");
    *long_rep_acceptats=pos;
    //for (j=i-rangacceptats+1;j<=i;j++) 
    //if (freqlong[j]>freqlong[(*long_rep_acceptats)]) *long_rep_acceptats=j;
  }
  else {
    //if (max<minnumreps)printf("\n Rao max %d<minnumreps %d\n",max,minnumreps);
    //if (pos<minlrep) printf("\n Rao pos<minlrep\n");
    //if (pos>maxlrep) printf("\n Rao pos>maxlrep\n");
    //if (numreps<minnumrepcluster) printf("Rao numreps<minnumrepcluster\n");
    *infoacceptat=0;
    (*rebutjats)++;
    //printf("\n REBUTJAT\n");
  }
}
